diff --git a/game/core/src/main/java/net/minecraft/core/item/material/ArmorMaterial.java b/game/core/src/main/java/net/minecraft/core/item/material/ArmorMaterial.java
index 33b9a23ca..6ccc1d40f 100644
--- a/game/core/src/main/java/net/minecraft/core/item/material/ArmorMaterial.java
+++ b/game/core/src/main/java/net/minecraft/core/item/material/ArmorMaterial.java
@@ -31,7 +31,7 @@ public class ArmorMaterial {
 	private final Map<DamageType, Float> protection = new HashMap<>();
 	
 	public ArmorMaterial(NamespaceID identifier, int durability) {
-		this.identifier = identifier.makePermanent();
+		this.identifier = identifier.copyUnpooled();
 		this.durability = durability;
 
 		ARMOR_MATERIALS.add(this);
@@ -50,37 +50,37 @@ public class ArmorMaterial {
 		return this;
 	}
 	
-	public static final ArmorMaterial LEATHER = register(new ArmorMaterial(NamespaceID.getPermanent("minecraft", "cloth"), 180)
+	public static final ArmorMaterial LEATHER = register(new ArmorMaterial(NamespaceID.fromPool("minecraft", "cloth"), 180)
 		.withProtectionPercentage(COMBAT, 20.0f)
 		.withProtectionPercentage(BLAST, 20.0f)
 		.withProtectionPercentage(FIRE, 20.0f)
 		.withProtectionPercentage(FALL, 120.0f)
 	);
-	public static final ArmorMaterial CHAINMAIL = register(new ArmorMaterial(NamespaceID.getPermanent("minecraft", "chain"), 240)
+	public static final ArmorMaterial CHAINMAIL = register(new ArmorMaterial(NamespaceID.fromPool("minecraft", "chain"), 240)
 		.withProtectionPercentage(COMBAT, 120.0f)
 		.withProtectionPercentage(BLAST, 35.0f)
 		.withProtectionPercentage(FIRE, 35.0f)
 		.withProtectionPercentage(FALL, 35.0f)
 	);
-	public static final ArmorMaterial IRON = register(new ArmorMaterial(NamespaceID.getPermanent("minecraft", "iron"), 200)
+	public static final ArmorMaterial IRON = register(new ArmorMaterial(NamespaceID.fromPool("minecraft", "iron"), 200)
 		.withProtectionPercentage(COMBAT, 45.0f)
 		.withProtectionPercentage(BLAST, 45.0f)
 		.withProtectionPercentage(FIRE, 45.0f)
 		.withProtectionPercentage(FALL, 45.0f)
 	);
-	public static final ArmorMaterial GOLD = register(new ArmorMaterial(NamespaceID.getPermanent("minecraft", "gold"), 120)
+	public static final ArmorMaterial GOLD = register(new ArmorMaterial(NamespaceID.fromPool("minecraft", "gold"), 120)
 		.withProtectionPercentage(COMBAT, 70.0f)
 		.withProtectionPercentage(BLAST, 70.0f)
 		.withProtectionPercentage(FIRE, 70.0f)
 		.withProtectionPercentage(FALL, 70.0f)
 	);
-	public static final ArmorMaterial DIAMOND = register(new ArmorMaterial(NamespaceID.getPermanent("minecraft", "diamond"), 800)
+	public static final ArmorMaterial DIAMOND = register(new ArmorMaterial(NamespaceID.fromPool("minecraft", "diamond"), 800)
 		.withProtectionPercentage(COMBAT, 66.0f)
 		.withProtectionPercentage(BLAST, 66.0f)
 		.withProtectionPercentage(FIRE, 124.0f)
 		.withProtectionPercentage(FALL, 66.0f)
 	);
-	public static final ArmorMaterial STEEL = register(new ArmorMaterial(NamespaceID.getPermanent("minecraft", "steel"), 1200)
+	public static final ArmorMaterial STEEL = register(new ArmorMaterial(NamespaceID.fromPool("minecraft", "steel"), 1200)
 		.withProtectionPercentage(COMBAT, 55.0f)
 		.withProtectionPercentage(BLAST, 150.0f)
 		.withProtectionPercentage(FIRE, 55.0f)
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShears.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShears.java
index f0f28e0b8..c1f011d87 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShears.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShears.java
@@ -57,7 +57,7 @@ public class ItemToolShears extends Item
         blockX += direction.getOffsetX();
         blockY += direction.getOffsetY();
         blockZ += direction.getOffsetZ();
-        AABB box = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX + 1, blockY + 1, blockZ + 1);
+        AABB box = AABB.fromPool(blockX, blockY, blockZ, blockX + 1, blockY + 1, blockZ + 1);
         List<MobSheep> entities = world.getEntitiesWithinAABB(MobSheep.class, box);
         if (!entities.isEmpty()) {
             entities.get(0).onItemInteract(itemStack);
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandBiome.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandBiome.java
index dced004ad..8c625f5fb 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandBiome.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandBiome.java
@@ -40,7 +40,7 @@ public class CommandBiome implements CommandManager.CommandRegistry {
                                     if (sourcePos == null) {
                                         c.getSource().sendTranslatableMessage("command.commands.biome.locate.success", Registries.BIOMES.getKey(biome), biomeLocation.getX(c.getSource()), biomeLocation.getZ(c.getSource()));
                                     } else {
-                                        int distance = (int)sourcePos.distanceTo(Vec3.getTempVec3(biomeLocation.getX(c.getSource()), sourcePos.y, biomeLocation.getZ(c.getSource())));
+                                        int distance = (int)sourcePos.distanceTo(Vec3.fromPool(biomeLocation.getX(c.getSource()), sourcePos.y, biomeLocation.getZ(c.getSource())));
                                         c.getSource().sendTranslatableMessage(distance == 1 ? "command.commands.biome.locate.success_in_world_single" : "command.commands.biome.locate.success_in_world_multiple", Registries.BIOMES.getKey(biome), biomeLocation.getX(c.getSource()), biomeLocation.getZ(c.getSource()), distance);
                                     }
                                     return Command.SINGLE_SUCCESS;
@@ -51,7 +51,7 @@ public class CommandBiome implements CommandManager.CommandRegistry {
         int[] xPattern = new int[]{0, 1, 0, -1};
         int[] zPattern = new int[]{1, 0, -1, 0};
         Vec3 sourcePos = source.getBlockCoordinates();
-        if (sourcePos == null) sourcePos = Vec3.getTempVec3(0.0, 0.0, 0.0);
+        if (sourcePos == null) sourcePos = Vec3.fromPool(0.0, 0.0, 0.0);
         int runLength = 2;
         int chunkX = (int)(sourcePos.x / 16.0);
         int y = (int)sourcePos.y;
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandClone.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandClone.java
index 0fb5cff75..bdc85300d 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandClone.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandClone.java
@@ -141,7 +141,7 @@ public class CommandClone implements CommandManager.CommandRegistry {
         int destinationY = destination.getPosition().getY(source, true);
         int destinationZ = destination.getPosition().getZ(source);
 
-        if (cloneMode == CloneMode.NORMAL && AABB.getTemporaryBB(minX, minY, minZ, maxX, maxY, maxZ).contains(Vec3.getTempVec3(destinationX, destinationY, destinationZ)) && start.getWorld() == destination.getWorld()) {
+        if (cloneMode == CloneMode.NORMAL && AABB.fromPool(minX, minY, minZ, maxX, maxY, maxZ).contains(Vec3.fromPool(destinationX, destinationY, destinationZ)) && start.getWorld() == destination.getWorld()) {
             throw INSIDE_CLONED_AREA.create();
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/helpers/BlockArgumentParser.java b/game/core/src/main/java/net/minecraft/core/net/command/helpers/BlockArgumentParser.java
index 190b8c2bf..411d0810d 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/helpers/BlockArgumentParser.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/helpers/BlockArgumentParser.java
@@ -17,7 +17,7 @@ import java.util.function.Consumer;
 
 public class BlockArgumentParser extends ArgumentParser {
     private static final SimpleCommandExceptionType INVALID_BLOCK = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.argument_types.block.invalid_block"));
-    public static final NamespaceID AIR_BLOCK = NamespaceID.getPermanent("minecraft", "block/air");
+    public static final NamespaceID AIR_BLOCK = NamespaceID.fromPool("minecraft", "block/air").copyUnpooled();
     private Block<?> block;
     private int metadata = 0;
     private CompoundTag tag = new CompoundTag();
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelector.java b/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelector.java
index 915d3165c..dfb149799 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelector.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelector.java
@@ -97,7 +97,7 @@ public class EntitySelector {
                 this.aABB.maxZ = this.aABB.maxZ + position.z;
             }
         } else {
-            position = this.position.apply(Vec3.getTempVec3(0, 0, 0));
+            position = this.position.apply(Vec3.fromPool(0, 0, 0));
         }
 
         List<? extends Entity> temp = new ArrayList<>(entities);
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorParser.java b/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorParser.java
index d7eaae07c..921213051 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorParser.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorParser.java
@@ -188,11 +188,11 @@ public class EntitySelectorParser {
             aABB = this.createAabb(this.deltaX == null ? 0.0 : this.deltaX, this.deltaY == null ? 0.0 : this.deltaY, this.deltaZ == null ? 0.0 : this.deltaZ);
         } else if (this.distance.getMax() != null) {
             double d = (Double) this.distance.getMax();
-            aABB = AABB.getTemporaryBB(-d, -d, -d, d + 1.0, d + 1.0, d + 1.0);
+            aABB = AABB.fromPool(-d, -d, -d, d + 1.0, d + 1.0, d + 1.0);
         } else {
             aABB = null;
         }
-        Function<Vec3, Vec3> position = this.x == null && this.y == null && this.z == null ? vec3 -> vec3 : vec3 -> Vec3.getTempVec3(this.x == null ? vec3.x : this.x, this.y == null ? vec3.y : this.y, this.z == null ? vec3.z : this.z);
+        Function<Vec3, Vec3> position = this.x == null && this.y == null && this.z == null ? vec3 -> vec3 : vec3 -> Vec3.fromPool(this.x == null ? vec3.x : this.x, this.y == null ? vec3.y : this.y, this.z == null ? vec3.z : this.z);
         return new EntitySelector(this.maxResults, this.includesEntities, this.order, this.limitToType, this.typeInverse, this.currentEntity, this.predicate, this.entityId, this.playerName, this.distance, position, aABB);
     }
 
@@ -206,7 +206,7 @@ public class EntitySelectorParser {
         double j = (bl ? 0.0 : d) + 1.0;
         double k = (bl2 ? 0.0 : e) + 1.0;
         double l = (bl3 ? 0.0 : f) + 1.0;
-        return AABB.getTemporaryBB(g, h, i, j, k, l);
+        return AABB.fromPool(g, h, i, j, k, l);
     }
 
     public void addPredicate(Predicate<Entity> predicate) {
diff --git a/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java b/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
index 06235b798..79c03b28a 100644
--- a/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
+++ b/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
@@ -1,51 +1,58 @@
 package net.minecraft.core.util.collection;
 
 import net.minecraft.core.util.HardIllegalArgumentException;
+import net.minecraft.core.util.pool.ObjectPool;
+import net.minecraft.core.util.pool.Poolable;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-import java.util.ArrayList;
-import java.util.List;
 import java.util.Objects;
 
-public final class NamespaceID implements Comparable<NamespaceID>, CharSequence {
+public final class NamespaceID implements Comparable<NamespaceID>, CharSequence, Poolable<NamespaceID> {
     public static final @NotNull String DEFAULT_NAMESPACE = "minecraft";
-    private static final List<NamespaceID> pool = new ArrayList<>();
-    private static int poolPointer = 0;
 
+    private static final @NotNull ObjectPool<NamespaceID> POOL = new ObjectPool<>(() -> new NamespaceID("default", "value"));
+
+    @Deprecated
     public static @NotNull NamespaceID getPermanent(final @NotNull String formattedKey) throws HardIllegalArgumentException {
         return new NamespaceID(formattedKey);
     }
 
+    @Deprecated
     public static @NotNull NamespaceID getPermanent(final @NotNull String namespace, final @NotNull String value) {
         return new NamespaceID(namespace, value);
     }
 
+    @Deprecated
     public static @NotNull NamespaceID getTemp(final @NotNull String formattedKey) throws HardIllegalArgumentException {
-        if(poolPointer >= pool.size())
-        {
-            pool.add(getPermanent(formattedKey));
-        }
-        return pool.get(poolPointer++).set(formattedKey);
+        return NamespaceID.POOL.get().set(formattedKey);
     }
 
+    @Deprecated
     public static @NotNull NamespaceID getTemp(final @NotNull String namespace, final @NotNull String value) {
-        if(poolPointer >= pool.size())
-        {
-            pool.add(getPermanent(namespace, value));
-        }
-        return pool.get(poolPointer++).set(namespace, value);
+        return NamespaceID.POOL.get().set(namespace, value);
     }
 
+    @Deprecated
     public static void deinitializePool()
     {
-        pool.clear();
-        poolPointer = 0;
+        NamespaceID.POOL.free();
     }
 
+    @Deprecated
     public static void initializePool()
     {
-        poolPointer = 0;
+        NamespaceID.POOL.reset();
+    }
+
+    public static @NotNull NamespaceID fromPool(final @NotNull String formattedKey)
+        throws HardIllegalArgumentException
+    {
+        return NamespaceID.POOL.get().set(formattedKey);
+    }
+
+    public static @NotNull NamespaceID fromPool(final @NotNull String namespace, final @NotNull String value) {
+        return NamespaceID.POOL.get().set(namespace, value);
     }
 
     private @NotNull String fullString;
@@ -60,6 +67,18 @@ public final class NamespaceID implements Comparable<NamespaceID>, CharSequence
         set(namespace, value);
     }
 
+    @Override
+    public @NotNull ObjectPool<NamespaceID> getPool() {
+        return NamespaceID.POOL;
+    }
+
+    @Override
+    public void set(final @NotNull NamespaceID other) {
+        this.fullString = other.fullString;
+        this.namespace = other.namespace;
+        this.value = other.value;
+    }
+
     @NotNull
     private NamespaceID set(final @NotNull String formattedKey) throws HardIllegalArgumentException {
         Objects.requireNonNull(formattedKey);
@@ -86,13 +105,9 @@ public final class NamespaceID implements Comparable<NamespaceID>, CharSequence
         return this;
     }
 
-    @NotNull
+    @Deprecated @NotNull
     public NamespaceID makePermanent(){
-        if (pool.contains(this)){
-            pool.remove(this);
-            poolPointer--;
-        }
-        return this;
+        return this.copyUnpooled();
     }
 
     public @NotNull String namespace() {
diff --git a/game/core/src/main/java/net/minecraft/core/util/linalg/Matrix4.java b/game/core/src/main/java/net/minecraft/core/util/linalg/Matrix4.java
new file mode 100644
index 000000000..bd8655293
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/util/linalg/Matrix4.java
@@ -0,0 +1,322 @@
+package net.minecraft.core.util.linalg;
+
+import net.minecraft.core.util.pool.ObjectPool;
+import net.minecraft.core.util.pool.Poolable;
+import org.jetbrains.annotations.NotNull;
+
+public class Matrix4
+    implements Poolable<Matrix4>
+{
+    private static final @NotNull ObjectPool<Matrix4> POOL = new ObjectPool<>(Matrix4::new);
+
+    /**
+     * The first column of the matrix.
+     */
+    public final @NotNull Vector4 x;
+
+    /**
+     * The second column of the matrix.
+     */
+    public final @NotNull Vector4 y;
+
+    /**
+     * The third column of the matrix.
+     */
+    public final @NotNull Vector4 z;
+
+    /**
+     * The fourth column of the matrix.
+     */
+    public final @NotNull Vector4 w;
+
+    /**
+     * Produces a pooled matrix with the given values.
+     */
+    public static @NotNull Matrix4 fromPool(
+        final double c0r0, final double c1r0, final double c2r0, final double c3r0,
+        final double c0r1, final double c1r1, final double c2r1, final double c3r1,
+        final double c0r2, final double c1r2, final double c2r2, final double c3r2,
+        final double c0r3, final double c1r3, final double c2r3, final double c3r3
+    ) {
+        return Matrix4.POOL.get().set(
+            c0r0, c1r0, c2r0, c3r0,
+            c0r1, c1r1, c2r1, c3r1,
+            c0r2, c1r2, c2r2, c3r2,
+            c0r3, c1r3, c2r3, c3r3
+        );
+    }
+
+    /**
+     * Produces the 4x4 identity matrix.
+     */
+    public static @NotNull Matrix4 identity() {
+        return Matrix4.fromPool(
+            1.0, 0.0, 0.0, 0.0,
+            0.0, 1.0, 0.0, 0.0,
+            0.0, 0.0, 1.0, 0.0,
+            0.0, 0.0, 0.0, 1.0
+        );
+    }
+
+    /**
+     * Calculates a perspective projection matrix with the given attributes; angles are given in radians.
+     */
+    public static @NotNull Matrix4 perspective(final double fovy, final double aspect, final double near, final double far) {
+        assert fovy > 0.0;
+        assert Math.abs(aspect) != 0.0;
+        assert near > 0.0;
+        assert far > 0.0;
+        assert near != far;
+
+        final double f = 1.0 / Math.tan(fovy / 2.0);
+
+        return Matrix4.fromPool(
+            f / aspect, 0.0, 0.0, 0.0,
+            0.0, f, 0.0, 0.0,
+            0.0, 0.0, (far + near) / (near - far), (2.0 * far * near) / (near - far),
+            0.0, 0.0, -1.0, 0.0
+        );
+    }
+
+    /**
+     * Calculates an orthographic projection matrix with the given attributes.
+     */
+    public static @NotNull Matrix4 ortho(final double left, final double right, final double bottom, final double top, final double near, final double far) {
+        return Matrix4.fromPool(
+            2.0 / (right - left), 0.0, 0.0, -(right + left) / (right - left),
+            0.0, 2.0 / (top - bottom), 0.0, -(top + bottom) / (top - bottom),
+            0.0, 0.0, -2.0 / (far - near), -(far + near) / (far - near),
+            0.0, 0.0, 0.0, 1.0
+        );
+    }
+
+    private Matrix4() {
+        this.x = Vector4.fromPool(0.0, 0.0, 0.0, 0.0).copyUnpooled();
+        this.y = Vector4.fromPool(0.0, 0.0, 0.0, 0.0).copyUnpooled();
+        this.z = Vector4.fromPool(0.0, 0.0, 0.0, 0.0).copyUnpooled();
+        this.w = Vector4.fromPool(0.0, 0.0, 0.0, 0.0).copyUnpooled();
+    }
+
+    @Override
+    public @NotNull ObjectPool<Matrix4> getPool() {
+        return Matrix4.POOL;
+    }
+
+    @Override
+    public void set(final @NotNull Matrix4 other) {
+        this.x.set(other.x);
+        this.y.set(other.y);
+        this.z.set(other.z);
+        this.w.set(other.w);
+    }
+
+    /**
+     * Sets the values of this matrix.
+     */
+    public @NotNull Matrix4 set(
+        final double c0r0, final double c1r0, final double c2r0, final double c3r0,
+        final double c0r1, final double c1r1, final double c2r1, final double c3r1,
+        final double c0r2, final double c1r2, final double c2r2, final double c3r2,
+        final double c0r3, final double c1r3, final double c2r3, final double c3r3
+    ) {
+        this.x.set(c0r0, c0r1, c0r2, c0r3);
+        this.y.set(c1r0, c1r1, c1r2, c1r3);
+        this.z.set(c2r0, c2r1, c2r2, c2r3);
+        this.z.set(c3r0, c3r1, c3r2, c3r3);
+
+        return this;
+    }
+
+    /**
+     * Translates this matrix by a given vector.
+     */
+    public @NotNull Matrix4 translate(final @NotNull Vector3 translation) {
+        return this.copyPooled().translateInPlace(translation);
+    }
+
+    /**
+     * Translates this matrix by a given vector, modifying it in place.
+     */
+    public @NotNull Matrix4 translateInPlace(final @NotNull Vector3 translation) {
+        final @NotNull Matrix4 translationMatrix = Matrix4.fromPool(
+            1.0, 0.0, 0.0, translation.x,
+            0.0, 1.0, 0.0, translation.y,
+            0.0, 0.0, 1.0, translation.z,
+            0.0, 0.0, 0.0, 1.0
+        );
+
+        return this.multInPlace(translationMatrix);
+    }
+
+    /**
+     * Scales this matrix by a given amount on all axes.
+     */
+    public @NotNull Matrix4 scale(final double scale) {
+        return this.copyPooled().scaleInPlace(scale);
+    }
+
+    /**
+     * Scales this matrix by a given amount on all axes, modifying it in place.
+     */
+    public @NotNull Matrix4 scaleInPlace(final double scale) {
+        return this.scaleInPlace(scale, scale, scale);
+    }
+
+    /**
+     * Scales this matrix by a given amount on each axis.
+     */
+    public @NotNull Matrix4 scale(final double x, final double y, final double z) {
+        return this.copyPooled().scaleInPlace(x, y, z);
+    }
+
+    /**
+     * Scales this matrix by a given amount on each axis, modifying it in place.
+     */
+    public @NotNull Matrix4 scaleInPlace(final double x, final double y, final double z) {
+        final @NotNull Matrix4 scaleMatrix = Matrix4.fromPool(
+            x, 0.0, 0.0, 0.0,
+            0.0, y, 0.0, 0.0,
+            0.0, 0.0, z, 0.0,
+            0.0, 0.0, 0.0, 1.0
+        );
+
+        return this.multInPlace(scaleMatrix);
+    }
+
+    /**
+     * Rotates this matrix on the X axis by the given angle.
+     */
+    public @NotNull Matrix4 rotX(final double radians) {
+        return this.copyPooled().rotXInPlace(radians);
+    }
+
+    /**
+     * Rotates this matrix on the X axis by the given angle, modifying it in place.
+     */
+    public @NotNull Matrix4 rotXInPlace(final double radians) {
+        final double sin = Math.sin(radians);
+        final double cos = Math.cos(radians);
+
+        final @NotNull Matrix4 rotMatrix = Matrix4.fromPool(
+            1.0, 0.0, 0.0, 0.0,
+            0.0, cos, -sin, 0.0,
+            0.0, sin, cos, 0.0,
+            0.0, 0.0, 0.0, 1.0
+        );
+
+        return this.multInPlace(rotMatrix);
+    }
+
+    /**
+     * Rotates this matrix on the Y axis by the given angle.
+     */
+    public @NotNull Matrix4 rotY(final double radians) {
+        return this.copyPooled().rotYInPlace(radians);
+    }
+
+    /**
+     * Rotates this matrix on the Y axis by the given angle, modifying it in place.
+     */
+    public @NotNull Matrix4 rotYInPlace(final double radians) {
+        final double sin = Math.sin(radians);
+        final double cos = Math.cos(radians);
+
+        final @NotNull Matrix4 rotMatrix = Matrix4.fromPool(
+            cos, 0.0, sin, 0.0,
+            0.0, 1.0, 0.0, 0.0,
+            -sin, 0.0, cos, 0.0,
+            0.0, 0.0, 0.0, 1.0
+        );
+
+        return this.multInPlace(rotMatrix);
+    }
+
+    /**
+     * Rotates this matrix on the Z axis by the given angle.
+     */
+    public @NotNull Matrix4 rotZ(final double radians) {
+        return this.copyPooled().rotZInPlace(radians);
+    }
+
+    /**
+     * Rotates this matrix on the Z axis by the given angle, modifying it in place.
+     */
+    public @NotNull Matrix4 rotZInPlace(final double radians) {
+        final double sin = Math.sin(radians);
+        final double cos = Math.sin(radians);
+
+        final @NotNull Matrix4 rotMatrix = Matrix4.fromPool(
+            cos, -sin, 0.0, 0.0,
+            sin, cos, 0.0, 0.0,
+            0.0, 0.0, 1.0, 0.0,
+            0.0, 0.0, 0.0, 1.0
+        );
+
+        return this.multInPlace(rotMatrix);
+    }
+
+    /**
+     * Multiplies this matrix by the given matrix.
+     */
+    public @NotNull Matrix4 mult(final @NotNull Matrix4 other) {
+        return this.copyPooled().multInPlace(other);
+    }
+
+    /**
+     * Multiplies this matrix by the given matrix, modifying it in place.
+     */
+    public @NotNull Matrix4 multInPlace(final @NotNull Matrix4 other) {
+        this.x.set(
+            this.x.x * other.x.x + this.y.x * other.x.y + this.z.x * other.x.z + this.w.x * other.x.w,
+            this.x.y * other.x.x + this.y.y * other.x.y + this.z.y * other.x.z + this.w.y * other.x.w,
+            this.x.z * other.x.x + this.y.z * other.x.y + this.z.z * other.x.z + this.w.z * other.x.w,
+            this.x.w * other.x.x + this.y.w * other.x.y + this.z.w * other.x.z + this.w.w * other.x.w
+        );
+        this.y.set(
+            this.x.x * other.y.x + this.y.x * other.y.y + this.z.x * other.y.z + this.w.x * other.y.w,
+            this.x.y * other.y.x + this.y.y * other.y.y + this.z.y * other.y.z + this.w.y * other.y.w,
+            this.x.z * other.y.x + this.y.z * other.y.y + this.z.z * other.y.z + this.w.z * other.y.w,
+            this.x.w * other.y.x + this.y.w * other.y.y + this.z.w * other.y.z + this.w.w * other.y.w
+        );
+        this.z.set(
+            this.x.x * other.z.x + this.y.x * other.z.y + this.z.x * other.z.z + this.w.x * other.z.w,
+            this.x.y * other.z.x + this.y.y * other.z.y + this.z.y * other.z.z + this.w.y * other.z.w,
+            this.x.z * other.z.x + this.y.z * other.z.y + this.z.z * other.z.z + this.w.z * other.z.w,
+            this.x.w * other.z.x + this.y.w * other.z.y + this.z.w * other.z.z + this.w.w * other.z.w
+        );
+        this.w.set(
+            this.x.x * other.w.x + this.y.x * other.w.y + this.z.x * other.w.z + this.w.x * other.w.w,
+            this.x.y * other.w.x + this.y.y * other.w.y + this.z.y * other.w.z + this.w.y * other.w.w,
+            this.x.z * other.w.x + this.y.z * other.w.y + this.z.z * other.w.z + this.w.z * other.w.w,
+            this.x.w * other.w.x + this.y.w * other.w.y + this.z.w * other.w.z + this.w.w * other.w.w
+        );
+
+        return this;
+    }
+
+    /**
+     * Transforms the given vector by this matrix.
+     */
+    public @NotNull Vector4 transform(final @NotNull Vector4 vec) {
+        return this.x.mult(vec.x).addInPlace(this.y.mult(vec.y)).addInPlace(this.z.mult(vec.z)).addInPlace(this.w.mult(vec.w));
+    }
+
+    /**
+     * Transforms the given vector by this matrix.
+     */
+    public @NotNull Vector3 transform(final @NotNull Vector3 vec) {
+        return this.transform(vec.extend(1.0)).truncate();
+    }
+
+    /**
+     * Returns the matrix as a column-major array.
+     */
+    public double @NotNull [] asArray() {
+        return new double[] {
+            this.x.x, this.x.y, this.x.z, this.x.w,
+            this.y.x, this.y.y, this.y.z, this.y.w,
+            this.z.x, this.z.y, this.z.z, this.z.w,
+            this.w.x, this.w.y, this.w.z, this.w.w
+        };
+    }
+}
